//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------


/*
===========================
=
= Bit manipulation
=
===========================
*/

#define TEST(flags,mask) ((flags) & (mask))
#define SET(flags,mask) ((flags) |= (mask))
#define RESET(flags,mask) ((flags) &= ~(mask))
#define FLIP(flags,mask) ((flags) ^= (mask))

// game_shared.h
// data shared between the exe and the DLL

typedef struct 
{
	void (*nextpage)(void);
	boolean (*build_Keydown)(byte key);
	void (*Load_Pallete)(char *filename);
	void (*rotatesprite)(long sx, long sy, long z, short a, short picnum,
                  signed char dashade, char dapalnum, char dastat,
                  long cx1, long cy1, long cx2, long cy2);
	void (*clearview)(long dacol);
	long   (*loadboard)(char *filename, char fromwhere, long *daposx, long *daposy, long *daposz, short *daang, short *dacursectnum);
	void (*SDL_Quit)(void);
	int  (*Decrypt_Map)(char *in, char *out);
	void (*displayLevel)(long posx, long posy, long posz, long ang,short snum,long smoothratio);
	long (*scale)(long i1, long i2, long i3);
	newPlayerInfo_t (*P_Movecode)(short ang, long fvel, long svel);
	int (*clipmove) (long *x, long *y, long *z, short *sectnum,
              long xvect, long yvect, long walldist, long ceildist,
              long flordist, unsigned long cliptype);

	int (*mulscale) (int input1, int input2, int input3);
	int (*pushmove)(long *x, long *y, long *z, short *sectnum,
             long walldist, long ceildist, long flordist,
             unsigned long cliptype);

	int (*ftotalclock)(void);
	void (*Set_Brightness)(int brightness);
	void (*getzrange)(long x, long y, long z, short sectnum,
			long *ceilz, long *ceilhit, long *florz, long *florhit,
			long walldist, unsigned long cliptype);
	spritetype *(*Game_GetSprite)(int i);
	void (*Justin_SetSky)(long pScale, short newpskyoff[256]);
	void (*build_ClearKey)(byte key);
	sectortype *(*GetSector)(int sectNum);
	int (*neartag)(long xs, long ys, long zs, short sectnum, short ange,
            short *neartagsector, short *neartagwall, short *neartagsprite,
            long *neartaghitdist, long neartagrange, char tagsearch);
	int (*hitscan)(long xs, long ys, long zs, short sectnum,
            long vx, long vy, long vz,
	        short *hitsect, short *hitwall, short *hitsprite,
	        long *hitx, long *hity, long *hitz, unsigned long cliptype);
	int (*krand)(void);
	void (*setviewtotile)(short tilenume, long xsiz, long ysiz);
	void (*setviewback)(void);
	short (*getTileX)(int tileNum);
	short (*getTileY)(int tileNum);
	void (*loadtile)(short tilenume);
	short *(*getSinTable)(void);
	short sintable[2048];
	char *(*getParam)(int param);
	walltype *(*get_Wall)(int wallNum);
	int (*cansee)(long x1, long y1, long z1, short sect1,
            long x2, long y2, long z2, short sect2);
	void (*drawline256) (long x1, long y1, long x2, long y2, unsigned char col);
	void (*Change_ScreenInfo)(int width, int height, int bpp, int antistrophy, int glBased, int fullscreen);
	xspritetype *(*GetXSprite)(int spritenum);
	void (*KBClearLastScanCode)(void);
	short (*getincangle)(short a,short na);
	xsectortype *(*GetXSector)(int sectorNum);
	xwalltype *(*GetXWall)(int wallNum);
	void   (*dragpoint)(short pointhighlight, long dax, long day);
	void   (*rotatepoint)(long xpivot, long ypivot, long x, long y, short daang, long *x2, long *y2);
	void   (*InsertSprite)(short sectnum, short sprnum, long x, long y, long z);
	long   (*spawnsprite)(long newspriteindex2, long x2, long y2, long z2, short cstat2, char shade2, char pal2,         
		                       char clipdist2, unsigned char xrepeat2, unsigned char yrepeat2, char xoffset2, char yoffset2, short picnum2, short ang2,       
		                       short xvel2, short yvel2, short zvel2, short owner2, long sectnum2, long statnum2, short lotag2, short hitag2, long extra2);
	long   (*deletesprite)(short spritenum);
	spritetype *(*unsafeGetSprite)(int i);
	long   (*changespritesect)(short spritenum, short newsectnum);
	boolean (*playerTouchSprite)(long playerx, long playery, long playerz,
						         long psectornum, long picnum);
	void   (*updatesector)(long x, long y, short *sectnum);
	char   (*build_gotpic)(long picnum);
	void   (*build_resetgotpic)(long picnum);
	long   (*inside)(long x, long y, short sectnum);
	long   (*getangle)(long xvect, long yvect);
}Game_Imports;

typedef struct 
{
	int (*RunFrame)(int totalclock);
	int (*GameShutdown)();
}Game_Exports;
