/*
 * mathutil.c
 * Mathematical utility functions to emulate MACT
 *
 * by Jonathon Fowler
 *
 * Since we weren't given the source for MACT386.LIB so I've had to do some
 * creative interpolation here.
 *
 */
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------

// mathutil.cpp

#include "game.h"

long sqrd(long in)
{
	return in  * in;
}

//
// boolean PointInCircle(int radius, int x, int y, int point1, int point2)
//
// I hate Geometry...Reinstein taught like crap...
//

int PointInCircle(int radius, int h, int k, int x, int y)
{
	if((sqrd((x - h)) + sqrd((y - k)) == radius))
		return 1;
	else
		return 0;
}

// This extracted from the Rise of the Triad source RT_UTIL.C :-|

#define SWAP(a,b) \
   {              \
   a=(a)^(b);     \
   b=(a)^(b);     \
   a=(a)^(b);     \
   }

int32 FindDistance2D(int32 x, int32 y)
{
  int32 t;

  x= abs(x);        /* absolute values */
  y= abs(y);

  if (x<y)
     SWAP(x,y);

  t = y + (y>>1);

  return (x - (x>>5) - (x>>7)  + (t>>2) + (t>>6));
}

long strlen(char *intxt)
{
	int position = 0;
	while(intxt[position] != NULL)
		position++;
	return position;
}