//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------
// soundManager.h

struct soundInfo_t
{
	string soundName;
};

struct playingSounds_t
{
	int soundId;
	int channel;
	int spritenum;
};

class soundManager_t : public Game
{
	public:
		soundManager_t();
        
		int  cacheMusic(char *filename);
		int  precache_Sound(char *filename,int hertz, int looping, int volume);
		void StopAllsounds(void);
		void PlayMusic(int musicID);
		void playsnd3d(int spriteid, int sndID);
		void soundPlay(int sndID);
		void FlushSystem(void);
	private:
		vector<FMUSIC_MODULE   *> cachedMusic;
		vector<soundInfo_t     *> worldSounds;
		vector<FSOUND_SAMPLE   *> cachedSounds;
		vector<playingSounds_t *> activeSounds;   
		vector<int>               sndvolume;
	protected:
		boolean failedInitSound;
};