//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------

// blood_main.c

#include "blood.h"

HMODULE gameLib;
Game_Exports *(*Game_API)(Game_Imports *gi);
char KB_LastScan;
Game_Exports *ge;
int (*RunFrame)(int totalclock);
void Loader_Error(char *err);

long oposx=0,oposy=0,oposz=0,oang=0;

int  maxArgs;
char *theseArgs;

#define GAME_BUILD "Engine build: " __DATE__ " " __TIME__ 
#define GAMETITLE "WinBlood - " GAME_BUILD

xspritetype *xsprites;
xsectortype *xsectors;
xwalltype   *xwalls;
//////////////////////////////////////////////
// block code so linker doesn't get pissy
//////////////////////////////////////////////

void timerhandler(void)
{
	totalclock++;
}

void faketimerhandler(void)
{
	
}

void STUBBED(char *whatever)
{

}

int ftotalclock(void)
{
	return totalclock;
}

void displayLevel(long posx, long posy, long posz, long ang,short snum,long smoothratio)
{
	  long cposx,cposy,cposz;
	  short sect, cang;

	  smoothratio = 65536;
      drawrooms(posx,posy,posz,ang,70,snum);
	  
     // animatesprites(posx,posy,ang,smoothratio);
      drawmasks();
}

void InsertSprite(short sectnum, short sprnum, long x, long y, long z)
{
	short thisspr;
	spritetype *spr2;

	thisspr = insertsprite(sectnum,0);
	spr2    = &sprite[thisspr];
	
	spr2->picnum = 0;
	spr2->x      = x;
	spr2->y      = y;
	spr2->z      = z;

	setsprite(sprnum,x,y,z);
}

/*
void Load_Pallete(char *filename)

No real reason this should change much
*/

void Load_Pallete(char *filename)
{
	long j,fp;
    signed char look_pos;
    char numl;
	unsigned char tempbuf[8192];

	loadpics("tiles000.art",32*1048576);
	printf(".....loading pallete %s\n",filename);

    fp = kopen4load(filename,0);
    if(fp != -1)
        kread(fp,(char *)&numl,1);
    else
        Loader_Error("\nERROR: File PALLETE not found.");

    for(j=0;j < numl;j++)
    {
        kread(fp,(signed char *)&look_pos,1);
        kread(fp,tempbuf,256);
        makepalookup((long)look_pos,tempbuf,0,0,0,1);
    }
	palette[765] = palette[766] = palette[767] = 0;

	printf(".....Loading ART\n");
    kclose(fp);
	setbrightness(10>>2,palette,0);
	setview(0,0,xdim-1,ydim-1);
	printf(".....game demensions %d %d\n",xdim, ydim);
}

/*
=====================================
void Set_Brightness(int brightness)
=====================================
*/

void Set_Brightness(int brightness)
{
	setbrightness(brightness>>2,palette,0);
}

/*
Loader_Error

Error Function...duh
*/

void Loader_Error(char *err)
{
	char tmp[10];
	SDL_Quit();
	printf(err);
	printf("Press any key to continue\n");
	gets(tmp);
	exit(0);
}
extern int decryptnumofsprites;
xspritetype *GetXSprite(int spritenum)
{
	return &xsprites[spritenum];
}

xsectortype *GetXSector(int sectorNum)
{
	return &xsectors[sectorNum];
}

int numwallsjustin;

xwalltype *GetXWall(int wallNum)
{
	return &xwalls[wallNum];
}

/*
Init_BuildEngine

Starts up the build engine
*/

void Init_BuildEngine(int argc, char argv[])
{
	initprintf("....Initliziazing Jonof build port\n");
	if (initengine()) {
	   wm_msgbox("Build Engine Initialisation Error", "There was a problem initialising the Build engine: %s", engineerrstr);
	   exit(1);
    }

	if(initinput() == -1)
	{
		wm_msgbox("Build Engine Initialisation Error", "There was a problem initialising the input engine: %s", engineerrstr);
	   exit(1);
    }

	inittimer(TICRATE);

	initprintf("....Creating Window\n");
	//setgamemode(0,800,600,16);
	//glanisotropy = 6;
	//gltexapplyprops();

}

sectortype *GetSector(int sectNum)
{
	if(sectNum >= numsectors)
		return NULL;

	return &sector[sectNum];
}

long   spawnsprite(long newspriteindex2, long x2, long y2, long z2, short cstat2, char shade2, char pal2,         
		                       char clipdist2, unsigned char xrepeat2, unsigned char yrepeat2, char xoffset2, char yoffset2, short picnum2, short ang2,       
		                       short xvel2, short yvel2, short zvel2, short owner2, long sectnum2, long statnum2, short lotag2, short hitag2, long extra2)
{                                                                      
	spritetype *spr2;  
	long thissprite = 0;
	thissprite = insertsprite(sectnum2,statnum2);                  
	spr2 = &sprite[thissprite];                                    
	spr2->x = x2; spr2->y = y2; spr2->z = z2;                           
	spr2->cstat = cstat2; spr2->shade = shade2;                         
	spr2->pal = palette; spr2->clipdist = clipdist2;                       
	spr2->xrepeat = xrepeat2; spr2->yrepeat = yrepeat2;                 
	spr2->xoffset = xoffset2; spr2->yoffset = yoffset2;                 
	spr2->picnum = picnum2; spr2->ang = ang2;                           
	spr2->xvel = xvel2; spr2->yvel = yvel2; spr2->zvel = zvel2;         
	spr2->owner = owner2;                                               
	spr2->lotag = lotag2; spr2->hitag = hitag2; spr2->extra = extra2;   
//	copybuf(&spr2->x,&osprite[thissprite].x,3);                    
	show2dsprite[thissprite>>3] &= ~(1<<(thissprite&7));      
	if (show2dsector[sectnum2>>3]&(1<<(sectnum2&7)))                    
		show2dsprite[thissprite>>3] |= (1<<(thissprite&7));    
	clearbufbyte(&spriteext[thissprite], sizeof(spriteexttype), 0);   

	return thissprite;
}

void Change_ScreenInfo(int width, int height, int bpp, int antistrophy, int glBased, int fullscreen)
{
	setgamemode(fullscreen,width,height,bpp);
	if(glBased == 1)
	{
		gltexfiltermode = 5; // force trilinear filtering
		glanisotropy    = antistrophy;
		gltexapplyprops();
	}
	else
	{
		setrendermode(1);
	}
}

spritetype *unsafeGetSprite(int i)
{
	return &sprite[i];
}

/*
Game_GetSprite

Returns a pointer to THIS sprite
*/
spritetype *Game_GetSprite(int i)
{
	int maxSize = headspritestat[6];
	
	if(maxSize <= i)
	{
	//	printf("GetSprite Out of bounds %d > %d\n",i,maxSize);
		return NULL;
	}

	return &sprite[i];
}

// build_Keydown
// key codes

boolean build_Keydown(byte key)
{
	boolean keypressed = KB_KeyPressed(key);

	if(keypressed == true)
		KB_LastScan = key;
	if(key == sc_Escape)
		KB_ClearKeyDown(key);
	
	if(key == sc_UpArrow)
		KB_ClearKeyDown(key);
	if(key == sc_DownArrow)
		KB_ClearKeyDown(key);
	if(key == sc_Enter)
		KB_ClearKeyDown(key);

	return keypressed;
}

short getincangle(short a,short na)
{
    a &= 2047;
    na &= 2047;

    if(klabs(a-na) < 1024)
        return (na-a);
    else
    {
        if(na > 1024) na -= 2048;
        if(a > 1024) a -= 2048;

        na -= 2048;
        a -= 2048;
        return (na-a);
    }
}

void KBClearLastScanCode(void)
{
	KB_KeyDown[ KB_LastScan ] = 0;
}

void build_ClearKey(byte key)
{
	KB_ClearKeyDown(key);
}

long scale_stub(long i1, long i2, long i3)
{
	return 1;
}

void Justin_SetSky(long pScale, short newpskyoff[256])
{
	// Setup the sky
	parallaxyscale = pScale;
    pskyoff[0]=newpskyoff[0]; pskyoff[1]=newpskyoff[1]; pskyoff[2]=newpskyoff[2]; pskyoff[3]=newpskyoff[3];
    pskyoff[4]=newpskyoff[4]; pskyoff[5]=newpskyoff[5]; pskyoff[6]=newpskyoff[6]; pskyoff[7]=newpskyoff[7];

	pskybits=3;
}

walltype *get_Wall(int wallNum)
{
	return &wall[wallNum];
};

short getTileY(int tileNum)
{
	return tilesizy[tileNum];
}

short getTileX(int tileNum)
{
	return tilesizx[tileNum];
}

short *getSinTable(void)
{
	return sintable;
}

char *getParam(int param)
{
	int thisParam = 0;
	int i         = 0;
	int c         = 0;
	char *thisArg = malloc(20);

	while(thisParam != param)
	{
		if(theseArgs[i] == ' ')
			thisParam++;

		if(i > strlen(theseArgs)) // buffer overrun.
			return NULL; 

		i++;
	}

	while(theseArgs[i] != ' ')
	{
		thisArg[c] = theseArgs[i];
		c++;
		i++;
	}
	return thisArg;
}

/*

playerTouchSprite

Sees if you are touching a sprite with that picnum
*/

boolean playerTouchSprite(long playerx, long playery, long playerz,
						  long psectornum, long picnum)
{
	long i,nexti;

	nexti = headspritesect[psectornum];

	for(i=headspritesect[psectornum];i>=0;i=nexti)
	{
		nexti = nextspritesect[i];

		if (sprite[i].cstat&0x8000) continue;
		if(sprite[i].picnum == picnum)
		{
			if ((klabs(playerx-sprite[i].x)+klabs(playery-sprite[i].y) < 512) && (klabs((playerz>>8)-((sprite[i].z>>8)-(tilesizy[sprite[i].picnum]>>1))) <= 40))
			{
				sprite[i].picnum = 4950;
				return TRUE;
			}
		}
	}

	return FALSE;
}

void build_resetgotpic(long picnum)
{
	RESET(gotpic[picnum >> 3], 1 << (picnum & 7));
}

char build_gotpic(long picnum)
{
	return gotpic[picnum];
}

/*
Launch_Game

Launches a Build game
*/
newPlayerInfo_t P_Movecode(short ang, long fvel, long svel);

void Launch_Game(char *gamedll)
{
	Game_Imports *gi = malloc(sizeof(Game_Imports));

	printf("Loading game code from %s\n",gamedll);
	gameLib = LoadLibrary(gamedll);

	if(!gameLib)
		Loader_Error("Failed to load gameDLL\n");

	Game_API = (Game_Exports *(__cdecl*)(Game_Imports*))GetProcAddress(gameLib,"Game_API");

	printf("Setting up exported functions\n");
	gi->nextpage       = nextpage;
	gi->build_Keydown  = build_Keydown;
	gi->Load_Pallete   = Load_Pallete;
	gi->rotatesprite   = rotatesprite;
	gi->clearview      = clearview;
	gi->loadboard      = loadboard;
	gi->SDL_Quit       = SDL_Quit;
	gi->Decrypt_Map    = Decrypt_Map;
	gi->displayLevel   = displayLevel;
	gi->scale          = scale_stub;
	gi->P_Movecode     = P_Movecode;
	gi->clipmove       = clipmove;
	gi->mulscale       = mulscale;
	gi->pushmove       = pushmove;
	gi->ftotalclock    = ftotalclock;
	gi->Set_Brightness = Set_Brightness;
	gi->getzrange      = getzrange;
	gi->Game_GetSprite = Game_GetSprite;
	gi->Justin_SetSky  = Justin_SetSky;
	gi->build_ClearKey = build_ClearKey;
	gi->GetSector      = GetSector;
	gi->neartag		   = neartag;
	gi->hitscan		   = hitscan;
	gi->krand		   = krand;
	gi->setviewback	   = setviewback;
	gi->setviewtotile  = setviewtotile;
	gi->getTileX	   = getTileX;
	gi->getTileY	   = getTileY;
	gi->loadtile	   = loadtile;
	gi->getSinTable    = getSinTable;
	gi->getParam	   = getParam;
	gi->get_Wall       = get_Wall;
	gi->cansee         = cansee;
	gi->drawline256    = drawline256;
	gi->GetXSprite	   = GetXSprite;
	gi->getincangle    = getincangle;
	gi->GetXSector     = GetXSector;
	gi->GetXWall       = GetXWall;
	gi->dragpoint      = dragpoint;
	gi->rotatepoint    = rotatepoint;
	gi->InsertSprite   = InsertSprite;
	gi->spawnsprite    = spawnsprite;
	gi->deletesprite   = deletesprite;
	gi->updatesector   = updatesector;
	gi->build_gotpic   = build_gotpic;
	gi->inside         = inside;
	gi->getangle       = getangle;
	gi->build_resetgotpic   = build_resetgotpic;
	gi->playerTouchSprite   = playerTouchSprite;
	gi->changespritesect    = changespritesect;
	gi->unsafeGetSprite     = unsafeGetSprite;
	gi->Change_ScreenInfo   = Change_ScreenInfo;
	gi->KBClearLastScanCode = KBClearLastScanCode;
	memcpy(gi->sintable,sintable,2048);


	if(!Game_API)
		Loader_Error("Failed to find game function\n");

	ge = Game_API(gi);
	RunFrame = ge->RunFrame;
}

/*
=============================================================
void P_Movecode(long posx, long posy, long posz, short ang)
=============================================================
*/



newPlayerInfo_t P_Movecode(short ang, long fvel, long svel)
{
	long i, j, k, doubvel, xvect, yvect, goalz;
	long dax, day;
	long cx, cy,cz,csec;
	newPlayerInfo_t playerinfo;
    
	doubvel = 1;

	xvect = ((fvel * doubvel*(long)sintable[(ang+512)&2047])>>3);
	yvect = ((svel * doubvel*(long)sintable[ang&2047])>>3);

    clipmove(&cx,&cy,&cz,&csec,xvect,yvect,128L,4<<8,4<<8,CLIPMASK0);
	playerinfo.x = cx;
	playerinfo.y = cy;
	playerinfo.z = cz;
	playerinfo.ang = ang;
	playerinfo.sector = csec;

	return playerinfo;
}
int nextvoxid = 0;

#ifdef OLD_ICCULUS
int main(int argc, char argv[])
#else
void app_main(int argc,char **argv)
#endif
{
    long i, j, k, l;
    int32 tempautorun;
	boolean game_running = true;

	if (win_checkinstance()) {
		if (!wm_ynbox("Blood","Another Build game is currently running. "
					"Do you wish to continue starting this copy?"))
			return;
	}

	strcpy(apptitle,GAMETITLE);
    initprintf("%s\n",apptitle);
    initprintf("Copyright 1996 Monlith Productions Inc\n");

	Init_BuildEngine(argc, argv);

	if (!loaddefinitionsfile("blood.def")) initprintf("Definitions file loaded.\n");

	totalclock = 0;

//	CoInitializeEx(NULL, COINIT_MULTITHREADED);
	Launch_Game("bloodx86.dll");

	ShowCursor(0);

	theseArgs = malloc(strlen(argv));

	maxArgs   = argc;
	strcpy(theseArgs,argv);


	while( game_running )
	{
		handleevents(); 
		if(!RunFrame(totalclock))
			game_running = false;
		//totalclock+=2;
	}
	uninittimer();
	uninitinput();
	uninitengine();
	ge->GameShutdown();
	FreeLibrary(gameLib);
	return 0;
}